--------------------------------------------------
-- FilePath.lua
-- 	2014/08/30 -
-- 					hksy
--------------------------------------------------

--[[
	Serial	= FilePath.SerialNumber(file)
	Serial
		:GetFile(num)
			1. int		num	t@C̔ԍ
						݃`FbN͍s܂

]]

--------------------------------------------------

FilePath	= {}

--------------------------------------------------

local function SplitLastStr(str, match, inc)
	if(inc==nil or inc)then	inc	= 0
	else			inc	=-1
	end
	local	index	= str:len()-str:reverse():find(match)+1
	return {str:sub(1,index+inc), str:sub(index+1)}
end

local function GetDigit(str,i)
	local tnum	= tonumber
	local sub	= string.sub
	local digit	= 0

	while(tnum( sub(str,i,i) ))do
		digit	= digit+1
		i	= i+1
	end
	return digit
end



--------------------------------------------------

-- t@C̃fBNg擾܂
-- C:\hoge\xxx_0123.bmp
--   -> C:\hoge\
-- 1. String	file	t@C̃pX
function FilePath.GetDirectory(file)
	return SplitLastStr(file, "\\")[1]
end

-- t@C̃t@C擾܂
-- C:\hoge\xxx_0123.bmp
--   -> xxx_0123.bmp
-- 1. String	file		t@C̃pX
-- 2. boolean	only	= false	t@Ĉ݂itrueŊgq܂܂ȂȂ܂j
function FilePath.GetFileName(file, only)
	only	= only	or false
	if(not only)then	return SplitLastStr(file, "\\")[2]
	else			return SplitLastStr(FilePath.GetFileName(file), "%.", false)[1]
	end
end

-- t@C̊gq擾܂
-- C:\hoge\xxx_0123.bmp
--   -> bmp
-- 1. String	file	t@C̃pX
function FilePath.GetExtension(file)
	return SplitLastStr(file, "%.")[2]
end

--------------------------------------------------
-- SerealNuberp
local function SN_GetFile(sn, num)
	return string.format("%s%s%0" .. sn.digit .. "d.%s", sn.path, sn.file, num, sn.ext)
end

local function SetSerial(sn)
	sn.GetFile	= SN_GetFile
end

--------------------------------------------------

-- AԑpIuWFNg쐬܂
-- 1. String	path	t@C̃pX
function FilePath.SerialNumber(file)
	local sn	= {}
	local fn	= FilePath.GetFileName(file, true)
	sn.path		= FilePath.GetDirectory(file)
	sn.ext		= FilePath.GetExtension(file)
	sn.digit	= GetDigit(fn:reverse(),1)
	sn.file		= fn:sub(1,fn:len()-sn.digit)

	SetSerial(sn)

	return sn
end


